// ------------------------------------------------------------
// Copyright (c) Microsoft Corporation and Dapr Contributors.
// Licensed under the MIT License.
// ------------------------------------------------------------

// Code generated by mockery v1.0.0.

package testing

import (
	"github.com/dapr/components-contrib/pubsub"
)

// MockPubSubAdapter is mock for PubSubAdapter
type MockPubSubAdapter struct {
	PublishFn   func(req *pubsub.PublishRequest) error
	GetPubSubFn func(pubsubName string) pubsub.PubSub
}

// Publish is an adapter method for the runtime to pre-validate publish requests
// And then forward them to the Pub/Sub component.
// This method is used by the HTTP and gRPC APIs.
func (a *MockPubSubAdapter) Publish(req *pubsub.PublishRequest) error {
	return a.PublishFn(req)
}

// GetPubSub is an adapter method to fetch a pubsub
func (a *MockPubSubAdapter) GetPubSub(pubsubName string) pubsub.PubSub {
	return a.GetPubSubFn(pubsubName)
}
